C#LeetCode刷题之#167-两数之和 II - 输入有序数组(Two Sum II - Input array is sorted)

问题

该文章的最新版本已迁移至个人博客【比特飞】,单击链接 https://www.byteflying.com/archives/3903 访问。

给定一个已按照升序排列 的有序数组,找到两个数使得它们相加之和等于目标数。

函数应该返回这两个下标值 index1 和 index2,其中 index1 必须小于 index2

说明:

  • 返回的下标值(index1 和 index2)不是从零开始的。
  • 你可以假设每个输入只对应唯一的答案,而且你不可以重复使用相同的元素。

输入: numbers = [2, 7, 11, 15], target = 9

输出: [1,2]

解释: 2 与 7 之和等于目标数 9 。因此 index1 = 1, index2 = 2 。


Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

Note:

  • Your returned answers (both index1 and index2) are not zero-based.
  • You may assume that each input would have exactly one solution and you may not use the same element twice.

Input: numbers = [2,7,11,15], target = 9

Output: [1,2]

Explanation: The sum of 2 and 7 is 9. Therefore index1 = 1, index2 = 2.


示例

该文章的最新版本已迁移至个人博客【比特飞】,单击链接 https://www.byteflying.com/archives/3903 访问。

public class Program {

    public static void Main(string[] args) {
        int[] prices = { 2, 7, 11, 15 };

        var res = TwoSum(prices, 9);
        Console.WriteLine($"[{res[0]},{res[1]}]");

        Console.ReadKey();
    }

    private static int[] TwoSum(int[] numbers, int target) {
        int left = 0, right = numbers.Length - 1, sum = 0;
        //双指针法,因为原数组已经有序
        //所有用左右指针分别指向首和尾
        //根据值的比较移动指针直到相撞时为止
        while(left < right) {
            sum = numbers[left] + numbers[right];
            //当2个值的和大于目标值时,左移右指针
            if(sum > target) right--;
            //当2个值的和小于目标值时,右移左指针
            else if(sum < target) left++;
            //匹配目标值时,直接返回
            else if(sum == target)
                return new int[] { left + 1, right + 1 };
        }
        //找不到时返回空数组
        return new int[] { };
    }

}

以上给出1种算法实现,以下是这个案例的输出结果:

该文章的最新版本已迁移至个人博客【比特飞】,单击链接 https://www.byteflying.com/archives/3903 访问。

[1,2]

分析:

显而易见,以上算法的时间复杂度为: O(n)

另外,因为是有序的数组,很容易想到使用二分查找,二分查找本身的时间复杂度为: O(logn) ,考虑到还需要一个原问题规模n的外循环,所以其时间复杂度应为: O(nlogn) , 有兴趣的同学可以自己动手试一下。

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值